#include <Fdo.h>
#include <iostream>

using namespace std;

char* LongStringToShortString(const wchar_t * ALongString)
{
	int Length = wcslen(ALongString);
	char* Result = new char[Length];
	wcstombs(Result,ALongString,Length);
	Result[Length] = 0;
	return Result;
}

void WaitForUser(string WaitMessage = "Press enter to continue ...")
{
	cout << WaitMessage; 
	string z;
	getline(cin,z); 	
}

int _tmain(int argc, _TCHAR* argv[])
{

	IConnectionManager *connmgr = FdoFeatureAccessManager::GetConnectionManager();
	FdoIConnection *conn = connmgr->CreateConnection(L"OSGeo.OGR.3.3");

	FdoIConnectionInfo *conninfo = conn->GetConnectionInfo();

	FdoIPropertyDictionary *connprops = conninfo->GetConnectionProperties();

	connprops->SetProperty(L"DataSource", L"C:\\temp\\shptest\\COUNCIL.TAB");
	connprops->SetProperty(L"ReadOnly", L"TRUE");

	state = conn->Open();

	FdoIDescribeSchema *dschema = (FdoIDescribeSchema *)conn->CreateCommand(FdoCommandType_DescribeSchema);
	FdoFeatureSchemaCollection *scoll = dschema->Execute();
	
	FdoISelect *select = (FdoISelect *)conn->CreateCommand(FdoCommandType_Select);
	select->SetFeatureClassName(L"COUNCIL");

	FdoFgfGeometryFactory *fgf = FdoFgfGeometryFactory::GetInstance();

	FdoIFeatureReader *reader = select->Execute();
	while(reader->ReadNext()) {
		FdoByteArray *bytearray = reader->GetGeometry(L"GEOMETRY");
		if(bytearray) {
			FdoIGeometry *geometry = fgf->CreateGeometryFromFgf(bytearray);
			if(geometry) {
				cout << "Geometry: " << LongStringToShortString(geometry->GetText()) << endl;
			}
		}
	}

	WaitForUser();
	return 0;
}

